package com.hai.schedule;

import com.hai.entity.HighUserCoupon;
import com.hai.service.HighUserCouponService;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.Scheduled;

import javax.annotation.Resource;
import java.util.List;

/**
 * @Auther: 胡锐
 * @Description: 卡卷定时任务
 * @Date: 2021/3/27 15:39
 */
@Configuration
public class HighCouponSchedule {

    @Resource
    private HighUserCouponService highUserCouponService;

    // @Scheduled(cron="0 0/1 * * * ?")  //每1分钟执行一次
    @Scheduled(cron = "0 0 0 * * ?")  //每天 凌晨0点执行
    public void certification() {
        List<HighUserCoupon> userCoupons = highUserCouponService.getOverdueCoupon();
        for (HighUserCoupon highUserCoupon : userCoupons) {
            highUserCoupon.setStatus(0);   // 状态  0:已过期  1：未使用  2：已使用
            highUserCouponService.updateUserCoupon(highUserCoupon);
        }
    }
}
