package com.hai.service;

import com.hai.entity.HighUser;
import com.hai.entity.SecSinopecConfig;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: SecSinopecConfigService
 * @Description: 中石化配置管理
 * @author: 袁野
 * @date: 2021/03/28 9:46
 * @Copyright: 2021 www.high.com Inc. All rights reserved.
 */
public interface SecSinopecConfigService {

    /**
     *
     * @Title: getListSinopecConfig
     * @Description:  查询列表
     * @Date: 2021/03/09 10:23
     * @author: Sum1Dream
     * @param: [map] map参数
     * @return: java.util.List<com.hai.entity.HighUser>
     * @throws Exception 抛出异常
     */

    List<SecSinopecConfig> getListSinopecConfig(Map<String , String> map) throws Exception;

    /**
     *
     * @Title: findById
     * @Description:  查询详情
     * @Date: 2021/03/09 10:23
     * @author: Sum1Dream
     * @param: userId 用户id
     * @return: HighUser
     */
    SecSinopecConfig findById(Integer sinopecId);

    /**
     *
     * @Title: updateSinopec
     * @Description: 修改信息
     * @author: Sum1Dream
     * @Date: 2021/03/09 11:23
     * @param: [highUser] 用户信息
     * @return: com.hai.entity.HighUser
     */
    void updateSinopec(SecSinopecConfig secSinopecConfig);

    /**
     *
     * @Title: insertSinopec
     * @Description: 新增
     * @author: Sum1Dream
     * @Date: 2021/03/09 11:23
     * @param: [highUser] 用户信息
     * @return: com.hai.entity.HighUser
     */
    void insertSinopec(SecSinopecConfig secSinopecConfig);

}
