package com.hai.service.impl;

import com.alibaba.fastjson.JSON;
import com.hai.dao.HighUserCouponMapper;
import com.hai.entity.HighUserCoupon;
import com.hai.entity.HighUserCouponExample;
import com.hai.model.HighUserCouponModel;
import com.hai.service.HighUserCouponService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Auther: 胡锐
 * @Description:
 * @Date: 2021/3/27 16:10
 */
@Service("highUserCouponService")
public class HighUserCouponServiceImpl implements HighUserCouponService {

    @Resource
    private HighUserCouponMapper highUserCouponMapper;

    @Override
    public void insertUserCoupon(HighUserCoupon highUserCoupon) {
        highUserCouponMapper.insert(highUserCoupon);
    }

    @Override
    public void updateUserCoupon(HighUserCoupon highUserCoupon) {
        highUserCouponMapper.updateByPrimaryKey(highUserCoupon);
    }

    @Override
    public List<HighUserCoupon> getOverdueCoupon() {
        HighUserCouponExample example = new HighUserCouponExample();
        example.createCriteria().andStatusEqualTo(1).andUseEndTimeGreaterThanOrEqualTo(new Date());
        return highUserCouponMapper.selectByExample(example);
    }

    @Override
    public HighUserCoupon getDetailByCodeId(Long couponCodeId) {

        HighUserCouponExample example = new HighUserCouponExample();
        example.createCriteria().andStatusEqualTo(1).andCouponCodeIdEqualTo(couponCodeId);
        List<HighUserCoupon> highUserCoupons = highUserCouponMapper.selectByExample(example);
        if (highUserCoupons.size() > 0) {
            return highUserCoupons.get(0);
        }
        return null;
    }

    @Override
    public List<HighUserCouponModel> getUserCouponList(Map<String, Object> map) {
        HighUserCouponExample example = new HighUserCouponExample();
        HighUserCouponExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map, "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(map, "userId"));
        }

        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }

        example.setOrderByClause("create_time desc");
        List<HighUserCoupon> highUserCoupons = highUserCouponMapper.selectByExample(example);
        if (highUserCoupons != null && highUserCoupons.size() > 0) {
            return JSON.parseArray(JSON.toJSONString(highUserCoupons), HighUserCouponModel.class);
        }
        return new ArrayList<>();
    }

    @Override
    public HighUserCoupon getUserCoupon(Long userId, Long couponId) {
        HighUserCouponExample example = new HighUserCouponExample();
        example.createCriteria().andUserIdEqualTo(userId).andCouponIdEqualTo(couponId);
        List<HighUserCoupon> coupons = highUserCouponMapper.selectByExample(example);
        if (coupons != null && coupons.size() > 0) {
            return coupons.get(0);
        }
        return null;
    }
}
